<?php

error_reporting(E_ALL);

/**
 * Require della classe gCloud_Monitoring
 */
require_once 'gCloud_Monitoring.php';

/*
 * Es. invio log 'semplice'
 * 
 * php -f exampleSendLog.php STREAMNAME AUTHKEY PROVAINVIO SHORTMESSAGE
 * 
 * Es. Invio log con parametri aggiuntivi
 * 
 * php -f exampleSendLog.php STREAMNAME AUTHKEY PROVAINVIO SHORTMESSAGE FULLMESSAGE 6 UUID NOMESCRIPT NUMERORIGA KEY1 VAL2 KEY2 VAL2
 */


if ($argc < 5) {
    die("\n\nAttenzione!\n\nNon hai specificato abbastanza parametri: \n" . $argv[0] . " <StreamName> <Authentication> <Facility <ShortMsg> [<FullMsg>] [<LogLevel>] [<file>] [<line>] \n\n");
}

$streamName = $argv[1];
$authentication = $argv[2];
$facility = $argv[3];
$shortMessage = $argv[4];
$fullMessage = (array_key_exists(5, $argv) ? $argv[5] : '');
$logLevel = (array_key_exists(6, $argv) && in_array($argv[6], array(0, 1, 2, 3, 4, 5, 6, 7)) ? $argv[6] : 6);
$file = (array_key_exists(7, $argv) ? $argv[7] : '');
$line = (array_key_exists(8, $argv) && is_numeric($argv[8]) ? (int) $argv[8] : 0);
$logMessageAdditionals = array();

// gestiamo gli eventuali parametri addizionali
if ($argc > 9) {

    $additionals = array_slice($argv, 9);
    $additionalsLength = count($additionals);

    if ($additionalsLength % 2 != 0) {
        die("\n\nAttenzione!\n\nNon hai specificato una sequenza corretta di parametri addizionali: indicali come <chiave> <valore>\n\n");
    }

    // estrae i parametri 2 alla volta (chiave -> valore)
    for ($index = 0; $index < $additionalsLength; $index = ($index + 2)) {
        $key = $additionals[$index];
        $value = $additionals[$index + 1];
        $logMessageAdditionals[$key] = $value;
    }
}

$gCloud_Monitoring = new gCloud_Monitoring($streamName, $authentication, 'REST');

$response = $gCloud_Monitoring->sendLog($shortMessage, $fullMessage, $logLevel, $facility, $file, $line, $logMessageAdditionals);

echo ($response === FALSE ? 'Errore invio' : 'Ok') . PHP_EOL;
